package ru.dbotthepony.mc.otm.client.screen.panels

import ru.dbotthepony.mc.otm.client.screen.MatteryScreen

open class GridPanel(
	screen: MatteryScreen<*>,
	parent: EditablePanel?,
	x: Float = 0f,
	y: Float = 0f,
	width: Float,
	height: Float,
	protected var columns: Int,
	protected var rows: Int
) : EditablePanel(screen, parent, x, y, width, height) {
	override fun performLayout() {
		var currentX = 0f
		var currentY = 0f
		var lineY = 0f
		var index = 0

		for (row in 0 until rows) {
			var column = 0

			while (column < columns) {
				val child = get(index) ?: break

				if (child.visible && child.dock === Dock.NONE) {
					lineY = lineY.coerceAtLeast(child.height + child.dockMargin.top + child.dockMargin.bottom)
					child.setPos(currentX + child.dockMargin.left, currentY + child.dockMargin.top)
					currentX += child.width + child.dockMargin.left + child.dockMargin.right
				} else {
					column--
				}

				index++
				column++
			}

			currentY += lineY
			currentX = 0f
			lineY = 0f

			get(index) ?: break
		}

		super.performLayout()
	}
}
