package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.SimpleContainer
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.core.ImmutableList
import ru.dbotthepony.mc.otm.block.entity.PatternStorageBlockEntity
import ru.dbotthepony.mc.otm.core.ImpreciseFraction
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget
import ru.dbotthepony.mc.otm.registry.MMenus

class PatternStorageMenu @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory,
	tile: PatternStorageBlockEntity? = null
) : MatteryMenu(
	MMenus.PATTERN_STORAGE, p_38852_, inventory, tile
) {
	val storedThis: LevelGaugeWidget
	val storedGrid: LevelGaugeWidget

	override val storageSlots: List<PatternSlot>

	init {
		if (tile == null) {
			storedThis = LevelGaugeWidget(this)
			storedGrid = LevelGaugeWidget(this)
		} else {
			storedThis = LevelGaugeWidget(this, tile)
			storedGrid = LevelGaugeWidget(this, {
				ImpreciseFraction(tile.matterGraph?.patternCount ?: 0)
			}, {
				ImpreciseFraction(tile.matterGraph?.patternCapacity ?: 0)
			})
		}

		val patterns = tile?.patternContainer ?: SimpleContainer(2 * 4)

		storageSlots = ImmutableList(2 * 4) {
			PatternSlot(patterns, it)
		}

		storageSlots.forEach(this::addSlot)

		addInventorySlots()
	}
}